## Welcome to the Xero-Node Docs!

This will provide an overview of how to use each of the SDK functions that have been made available within the xero-node SDK.

[Getting Started? Click here first!](./Creating-an-SDK-Client.md)

[Looking for a Sample App? Click here!](./Sample-App-Setup.md)

The following Xero API functions are supported:

**Accounting API**
* [Accounts](./Accounts.md)
* [Bank Transactions](./Bank-Transactions.md)
* [Bank Transfers](./Bank-Transfers.md)
* [Branding Themes](./Branding-Themes.md)
* [Contacts](./Contacts.md)
* [Credit Notes (and Allocations)](./Credit-Notes.md)
* [Currencies](./Currencies.md)
* [Invoices](./Invoices.md)
* [Invoice Reminders](./Invoice-Reminders.md)
* [Items](./Items.md)
* [Journals](./Journals.md)
* [Organisations](./Organisations.md)
* [Payments](./Payments.md)
* [Reports (except BAS/GST)](./Reports.md)
* [Tax Rates](./Tax-Rates.md)
* [Tracking Categories (and Tracking Options)](./Tracking-Categories.md)
* [Users](./Users.md)

Endpoints not currently supported:

* Attachments
* Contact Groups
* Employees (not Payroll)
* Expense Claims
* Linked Transactions
* Manual Journals
* Overpayments
* Prepayments
* Purchase Orders
* Quotes
* Receipts
* Repeating Invoices
* Setup

### Other Xero APIs

Support for the other Xero APIs is not currently available, but is coming soon.

* Payroll API - AU
* Payroll API - US
* Assets
* Files
* Xero Practice Manager


If you need further support, please raise an issue in Github or contact api@xero.com.


